/* GCC */

#include <iostream>
#include <fstream>
#include <vector>
#include <cmath>

using namespace std;
const __int64 inf=pow(2, 61);
const int n=10;
int m, l;
int steps[n][n];
vector< vector<int> > price;
vector<int> nums;
vector<bool> was(inf/10, false);
__int64 ans=0, ansMin=inf, ansMax=0;

bool in(int a, vector<int> b){
    for(int i=0; i<b.size(); i++){
        if(b[i]==a) return true;
    }
    return false;
}

void findNext(int curr, int sum, int day){
    if(day==m){
        if(!was[sum] && !in(sum, nums)){
            was[sum]=true;
            ans++;
            if(sum<ansMin) ansMin=sum;
            if(sum>ansMax) ansMax=sum;
        }
        return;
    }
    sum+=price[day][curr];
    for(int i=0; i<n; i++){
        if(steps[curr][i]==0) continue;
        findNext(i, sum, day+1);
    }
}

int main(){
    ifstream fin("caves.in");
    ofstream fout("caves.out");



    fin>>m>>l;
    int i, z;
    for(i=0; i<n; i++){
        for(z=0; z<n; z++){
            fin>>steps[i][z];
        }
    }
    price=vector< vector<int> >(m, vector<int>(n));
    nums=vector<int>(l);
    for(i=0; i<m; i++){
        for(z=0; z<n; z++){
            fin>>price[i][z];
        }
    }
    for(i=0; i<=l; i++){
        fin>>nums[i];
    }

    for(i=0; i<n; i++){
        findNext(i, 0, 0);
    }

    fout<<ans<<' '<<ansMax<<' '<<ansMin<<endl;

    fin.close();
    fout.close();
    return 0;
}
