/* GCC */
#include <cstdio>
#include <vector>
#include <algorithm>
using namespace std;

bool A[10][10];
vector<long long> Ans[2][10];

vector<long long> merg( const vector<long long> & a, const vector<long long> & b, long long bx){
    vector<long long> c; c.clear();
    int i = 0, j = 0, n = a.size(), m = b.size();
    while(i < n && j < m){
        if(a[i] < b[j]+bx) { c.push_back(a[i]); i++; }
        else if (a[i] > b[j]+bx) { c.push_back(b[j]+bx); j++; }
        else if (a[i]  == b[j]+bx) { c.push_back(a[i]); i++; j++; }
    }
    while(i < n) { c.push_back(a[i]); i++; }
    while(j < m) { c.push_back(b[j]+bx); j++; }
    return c;
}

vector<long long> mmerg( const vector<long long> & a, const vector<long long> & b){
    vector<long long> c; c.clear();
    int i = 0, j = 0, n = a.size(), m = b.size();
    while(i < n && j < m){
        if(a[i] < b[j]) { c.push_back(a[i]); i++; }
        else if (a[i] > b[j]) { j++; }
        else if (a[i]  == b[j]) { i++; j++; }
    }
    while(i < n) { c.push_back(a[i]); i++; }
    //while(j < m) { c.push_back(b[j]+bx); j++; }
    return c;
}

int main(){
    freopen("caves.in", "r", stdin);
    freopen("caves.out", "w", stdout);
    int m, l;
    scanf("%d%d", &m, &l);
    vector<long long> L(l);
    for(int i = 0; i < 10; i++) for(int j = 0; j < 10; j++) scanf("%d", &A[i][j]);
    long long B[m][10];
    for(int i = 0; i < m; i++) for(int j = 0; j < 10; j++) scanf("%I64d", &B[i][j]);
    for(int i = 0; i < l; i++) scanf("%I64d", &L[i]);
    fclose(stdin);

    int p = 0, pp;
    for(int i = 0; i < 10; i++) Ans[p][i].assign(1,0);

    for(int i = 0; i < m; i++){
        pp = p; p = 1-p;
        for(int j = 0; j < 10; j++){
            Ans[p][j].clear();
            for(int k = 0; k < 10; k++) if (A[j][k])
                Ans[p][j] = merg(Ans[p][j], Ans[pp][k], B[i][j]);
        }
    }

    vector<long long> AAns;
    AAns.clear();
    sort(L.begin(), L.end());
    for(int i = 0; i < 10; i++) AAns = merg(AAns, Ans[p][i], 0);

    AAns = mmerg(AAns, L);
    if(AAns.size() == 0) {printf("0 0 0\n"); fclose(stdout); return 0; }
    long long N = AAns.size();
    printf("%I64d %I64d %I64d\n", N, AAns.back(), AAns.front());

    fclose(stdout);
    return 0;
}
