/* GCC */
#include <iostream>
#include <cmath>
#include <algorithm>
#include <cstdio>
#include <vector>

using namespace std;
typedef long long ll;

int g[10][10];
int prise[100000][10];
int m, l;
vector <int> king;
ll pmax = 0, pmin = 1e18, nw;

inline void dfs(int v, int day, int p) {
    if(day == m) {
        for(int i = 0; i < king.size(); i++)
            if(king[i] == p)
                return;

        nw++;
        if(pmax < p)
            pmax = p;
        if(pmin > p)
            pmin = p;

        return;
    }


    for(int i = 0; i < 10; i++)
        if(g[v][i])
            dfs(i, day + 1, p + prise[day][i]);
}

int main() {
    freopen("caves.in", "r", stdin);
    freopen("caves.out", "w", stdout);

    scanf("%d%d", &m, &l);

    for(int i = 0; i < 10; i++)
        for(int j = 0; j < 10; j++)
            scanf("%d", &g[i][j]);

    for(int i = 0; i < m; i++)
        for(int j = 0; j < 10; j++)
            scanf("%d", &prise[i][j]);


    for(int i = 0; i < l; i++) {
        int x;
        scanf("%d", &x);
        king.push_back(x);
    }

    for(int i = 0; i < 10; i++)
        dfs(i, 1, prise[0][i]);

    cout << nw << ' ' << pmax << ' ' << pmin << endl;
}
