/* GCC */
#include <fstream>
#include <vector>
#include <algorithm>
#include <limits>

using namespace std;
typedef unsigned long long uint64;
int tmp, ans(0), m, l;
uint64 c[60][10], mn(numeric_limits<uint64>::max()), mx(0);
vector<int> gr[11];
vector<uint64> kings, dp[61][11];

inline void add(vector<uint64>& v, uint64 elem)
{
    if(v.empty() || v.back() != elem)
        v.push_back(elem);
}

void merge(int day, int cave, uint64 bonus)
{
    vector<int> idxs(gr[cave].size());
    int cur_cave;
    while(true)
    {
        int mx_cave = -1;
        for(int i = 0; i < idxs.size(); ++i)
        {
            cur_cave = gr[cave][i];
            if(idxs[i] != dp[day - 1][cur_cave].size() &&
               (mx_cave == -1 || dp[day - 1][cur_cave][idxs[i]]
                   > dp[day - 1][gr[cave][mx_cave]][idxs[mx_cave]]))
                    mx_cave = i;
        }
        if(mx_cave == -1)
            break;
        add(dp[day][cave], dp[day - 1][gr[cave][mx_cave]][idxs[mx_cave]] + bonus);
        ++idxs[mx_cave];
    }
}

int main(void)
{
    ios_base::sync_with_stdio(false);
    for(int i = 0; i < 10; ++i)
        gr[10].push_back(i);
    ifstream in("caves.in");
    in >> m >> l;
    kings.resize(l);
    for(int i = 0; i < 10; ++i)
        for(int j = 0; j < 10; ++j)
        {
            in >> tmp;
            if(tmp == 1)
                gr[i].push_back(j);
        }
    for(int i = 0; i < m; ++i)
        for(int j = 0; j < 10; ++j)
            in >> c[i][j];
    for(int i = 0; i < l; ++i)
        in >> kings[i];
    in.close();
    for(int i = 0; i < 10; ++i)
        dp[0][i].push_back(c[0][i]);
    for(int day = 1; day < m; ++day)
    {
        for(int cave = 0; cave < 10; ++cave)
            merge(day, cave, c[day][cave]);
        for(int cave = 0; cave < 10; ++cave)
            vector<uint64>().swap(dp[day - 1][cave]);
    }
    merge(m, 10, 0);
    for(int i = 0, ki = 0; i < dp[m][10].size(); ++i)
    {
        while(ki < kings.size() && kings[ki] > dp[m][10][i])
            ++ki;
        if(ki == kings.size() || dp[m][10][i] != kings[ki])
        {
            ++ans;
            if(dp[m][10][i] > mx)
                mx = dp[m][10][i];
            if(dp[m][10][i] < mn)
                mn = dp[m][10][i];
        }
    }
    ofstream out("caves.out");
    out << ans << ' ' << mx << ' ' << mn << '\n';
    out.close();
    return 0;
}
