/* GCC */

#include <iostream>
#include <fstream>
#include <vector>
#include <cmath>

using namespace std;
const int inf=10000000;

struct dot{
    int x;
    int y;
    bool used;
};

int n;
const float pi=3.1415926525;
vector<dot> dots;
vector< vector<int> > borders;

void show(vector<dot> a){
    for(int i=0; i<a.size(); i++){
        cout<<a[i].x<<' '<<a[i].y<<"   ";
    }
    cout<<endl<<endl;
}

float dist(dot a, dot b){
    return sqrt(pow(a.x-b.x, 2)+pow(a.y-b.y, 2));
}

float r(float a){
    __int64 q=1000000;
    return trunc(a*q)/q;
}

void buildBorder(int start){
    borders.push_back(vector<int>());
    borders[borders.size()-1].push_back(start);
    int curr=start;

    //finding second
    int minY=inf;
    int lower;
    for(int i=1; i<=n; i++){
        if(i==curr || dots[i].used) continue;
        if(dots[i].y<minY || (dots[i].y==minY && dots[i].x<dots[lower].x)){
            minY=dots[i].y;
            lower=i;
        }

    }
    int prev=curr;
    curr=lower;

    /*dots[0].x=dots[start].x;
    dots[0].y=dots[start].y+1;
    int prev=0;*/
    do{
        float minCos=1;
        int toNext;
        float currCos;
        //check all other dots
        for(int i=1; i<=n; i++){
            if(i==curr || dots[i].used) continue;
            //finding corner
            float a=dist(dots[prev], dots[curr]);
            float b=dist(dots[i], dots[curr]);
            float c=dist(dots[i], dots[prev]);
            currCos=(a*a+b*b-c*c)/(2*a*b);
            cout<<a<<' '<<b<<' '<<c<<endl;

            cout<<curr<<' '<<i<<' '<<r(currCos)<<' '<<r(minCos)<<endl<<endl;;

            if(currCos<minCos){
                minCos=currCos;
                toNext=i;
            }
            if(currCos==minCos && (dots[i].x<dots[toNext].x || dots[i].y<dots[toNext].y)){

                minCos=currCos;
                toNext=i;
            }
        }
        borders[borders.size()-1].push_back(toNext);
        prev=curr;
        curr=toNext;
        dots[toNext].used=true;
        cout<<toNext<<endl;

    } while(curr!=start);
}

int main(){
    ifstream fin("polyline.in");
    ofstream fout("polyline.out");

    fin>>n;
    int i;
    dot a;
    dots.push_back(a);
    int minX=inf;
    int left;

    /*for(i=1; i<=n; i++){
        fin>>a.x;
        fin>>a.y;
        a.used=false;
        dots.push_back(a);

        if((a.x<minX) || (a.x==minX && a.y<dots[left].y)){
            minX=a.x;
            left=i;
        }
    }
    //show(dots);


    buildBorder(left);*/

    fout<<0<<endl;




    fin.close();
    fout.close();
    return 0;
}
