/* GCC */
#include <iostream>
#include <fstream>
#include <vector>

using namespace std;

typedef unsigned long long ull;

const int n=10;

int m, l, pnt[n+1];
vector <int> arr[n+1];
vector <ull> adp[2][n+1];

int main()
{
    ios::sync_with_stdio(0);
    ifstream cin("caves.in");
    ofstream cout("caves.out");
    cin >> m >> l;
    for(int i=1; i<=n; ++i)
    {
        for(int j=1; j<=n; ++j)
        {
            int in;
            cin >> in;
            if(in)
                arr[i].push_back(j);
        }
        adp[0][i].push_back(0);
    }
    for(int d=1; d<=m; ++d)
    {
        bool b=d&1;
        for(int v=1; v<=n; ++v)
        {
            adp[b][v].clear();
            ull in;
            cin >> in;
            for(int i=0; i<arr[v].size(); ++i)
                pnt[arr[v][i]]=0;
            int remain=arr[v].size();
            while(remain)
            {
                ull mx=0;
                for(int i=0; i<arr[v].size(); ++i)
                {
                    int to=arr[v][i];
                    if(pnt[to]<adp[!b][to].size())
                        mx=max(mx, adp[!b][to][pnt[to]]);
                }
                adp[b][v].push_back(mx+in);
                for(int i=0; i<arr[v].size(); ++i)
                {
                    int to=arr[v][i];
                    while(pnt[to]<adp[!b][to].size()&&adp[!b][to][pnt[to]]==mx)
                    {
                        ++pnt[to];
                        if(pnt[to]==adp[!b][to].size())
                            --remain;
                    }
                }
            }
        }
    }
    bool b=m&1;
    int remain=n;
    for(int v=1; v<=n; ++v)
    {
        pnt[v]=0;
        adp[!b][v].clear();
    }
    vector <ull> ans;
    while(l--)
    {
        ull in, mx=0;
        cin >> in;
        for(int v=1; v<=n; ++v)
            if(pnt[v]<adp[b][v].size())
                mx=max(mx, adp[b][v][pnt[v]]);
        while(remain&&mx>=in)
        {
            if(mx!=in)
                ans.push_back(mx);
            for(int v=1; v<=n; ++v)
                while(pnt[v]<adp[b][v].size()&&adp[b][v][pnt[v]]==mx)
                {
                    ++pnt[v];
                    if(pnt[v]==adp[b][v].size())
                        --remain;
                }
            mx=0;
            for(int v=1; v<=n; ++v)
                if(pnt[v]<adp[b][v].size())
                    mx=max(mx, adp[b][v][pnt[v]]);
        }
    }
    if(ans.size()!=0) cout << ans.size() << ' ' << ans[0] << ' ' << ans[ans.size()-1] << endl;
    else cout << "0 0 0\n";
    return 0;
}
